From e572637bb33473546262df0ba892f4254727ba45 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Sep 28 2017 17:35:09 +0000
Subject: [PATCH 960/1001] Make the Halp REST API similar to the main REST API


---

diff --git a/hubs/tests/widgets/test_halp.py b/hubs/tests/widgets/test_halp.py
index 53c27f6..715fa78 100644
--- a/hubs/tests/widgets/test_halp.py
+++ b/hubs/tests/widgets/test_halp.py
@@ -152,13 +152,15 @@ class HalpViewsTestCase(WidgetTest):
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data, {
-            'results': ['decause', 'devyani7', 'dhrish', 'i18n', 'infra']
+            'status': 'OK',
+            'data': ['decause', 'devyani7', 'dhrish', 'i18n', 'infra']
         })
         response = self.app.get('/w/halp/hubs?q=de')
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data, {
-            'results': ['decause', 'devyani7']
+            'status': 'OK',
+            'data': ['decause', 'devyani7']
         })
 
     def test_data(self):
@@ -167,13 +169,19 @@ class HalpViewsTestCase(WidgetTest):
         response = self.app.get('/ralph/w/halp/%i/data' % self.widget.idx)
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
-        self.assertEqual(data, {"requests": expected[:3]})
+        self.assertEqual(data, {
+            'status': 'OK',
+            "data": {"requests": expected[:3]}
+        })
         # Test with the right hub selected
         response = self.app.get('/ralph/w/halp/%i/data?hubs=decause'
                                 % self.widget.idx)
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
-        self.assertEqual(data, {"requests": expected[3:5]})
+        self.assertEqual(data, {
+            'status': 'OK',
+            "data": {"requests": expected[3:5]},
+        })
 
     def test_data_wrong_hub(self):
         # Test with the wrong hub selected
@@ -181,7 +189,9 @@ class HalpViewsTestCase(WidgetTest):
                                 % self.widget.idx)
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
-        self.assertEqual(data, {"requests": []})
+        self.assertEqual(data, {
+            'status': 'OK', "data": {"requests": []}
+        })
 
     def test_search_requesters(self):
         response = self.app.get(
@@ -189,15 +199,16 @@ class HalpViewsTestCase(WidgetTest):
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data, {
-            'results': ['jborean93', 'jkurik', 'mattdm', 'nitzmahone',
-                        'stoney']
-        })
+            'status': 'OK',
+            'data': ['jborean93', 'jkurik', 'mattdm', 'nitzmahone', 'stoney']
+            })
         response = self.app.get(
             '/ralph/w/halp/%i/requesters?q=j' % self.widget.idx)
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data, {
-            'results': ['jborean93', 'jkurik']
+            'status': 'OK',
+            'data': ['jborean93', 'jkurik']
         })
 
     def test_search_all(self):
@@ -207,7 +218,8 @@ class HalpViewsTestCase(WidgetTest):
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         self.assertEqual(data, {
-            "requests": expected[:3],
+            'status': 'OK',
+            'data': {"requests": expected[:3]},
             'page': {
                 'has_next': True,
                 'has_prev': False,
@@ -222,7 +234,8 @@ class HalpViewsTestCase(WidgetTest):
         self.assertEqual(response.status_code, 200)
         data = json.loads(response.get_data(as_text=True))
         self.assertEqual(data, {
-            "requests": expected[3:],
+            'status': 'OK',
+            'data': {"requests": expected[3:]},
             'page': {
                 'has_next': False,
                 'has_prev': True,
@@ -239,7 +252,8 @@ class HalpViewsTestCase(WidgetTest):
         data = json.loads(response.get_data(as_text=True))
         expected = self._get_sample_data_with_hub_keys()
         self.assertEqual(data, {
-            "requests": expected[0:1],
+            'status': 'OK',
+            "data": {"requests": expected[0:1]},
             'page': {
                 'has_next': False,
                 'has_prev': False,
@@ -256,7 +270,8 @@ class HalpViewsTestCase(WidgetTest):
         data = json.loads(response.get_data(as_text=True))
         expected = self._get_sample_data_with_hub_keys()
         self.assertEqual(data, {
-            "requests": expected[3:4],
+            'status': 'OK',
+            "data": {"requests": expected[3:4]},
             'page': {
                 'has_next': False,
                 'has_prev': False,
@@ -273,7 +288,8 @@ class HalpViewsTestCase(WidgetTest):
         data = json.loads(response.get_data(as_text=True))
         expected = self._get_sample_data_with_hub_keys()
         self.assertEqual(data, {
-            "requests": expected[1:2],
+            'status': 'OK',
+            "data": {"requests": expected[1:2]},
             'page': {
                 'has_next': False,
                 'has_prev': False,
@@ -291,7 +307,8 @@ class HalpViewsTestCase(WidgetTest):
         data = json.loads(response.get_data(as_text=True))
         expected = self._get_sample_data_with_hub_keys()
         self.assertEqual(data, {
-            "requests": expected[1:2],
+            'status': 'OK',
+            "data": {"requests": expected[1:2]},
             'page': {
                 'has_next': False,
                 'has_prev': False,
diff --git a/hubs/widgets/halp/functions.py b/hubs/widgets/halp/functions.py
index 0191710..c99f611 100644
--- a/hubs/widgets/halp/functions.py
+++ b/hubs/widgets/halp/functions.py
@@ -29,7 +29,6 @@ class GetRequests(CachedFunction):
     TOPIC = "org.fedoraproject.prod.meetbot.meeting.item.help"
 
     def execute(self):
-        # return [_format_message(msg) for msg in EXAMPLE_DATA]
         raw_messages = datagrepper_get({
             "topic": self.TOPIC,
             "delta": str(86400 * 10),  # 10 days
diff --git a/hubs/widgets/halp/views.py b/hubs/widgets/halp/views.py
index 184140f..d8a0c41 100644
--- a/hubs/widgets/halp/views.py
+++ b/hubs/widgets/halp/views.py
@@ -24,12 +24,15 @@ class DataView(WidgetView):
     json = True
 
     def get_context(self, instance, *args, **kwargs):
-        get_requests = GetRequests(instance)
         data = {"requests": []}
+        get_requests = GetRequests(instance)
         requests = get_requests() or []
+        # from .functions import _format_message, EXAMPLE_DATA
+        # requests = [_format_message(msg) for msg in EXAMPLE_DATA]
         hubs_filter = flask.request.args.getlist("hubs")
         for req in requests:
             req["hubs"] = find_hubs_for_msg(req)
+            # req["hubs"] = ["infrastructure", "commops"]
             if not req["hubs"]:
                 continue
             req["hub"] = req["hubs"][0]  # Arbitrarily assign the first hub.
@@ -44,7 +47,7 @@ class DataView(WidgetView):
             if len(data["requests"]) == 3:
                 # Only 3 requests on the main widget.
                 break
-        return data
+        return dict(status="OK", data=data)
 
 
 class SearchView(WidgetView):
@@ -101,8 +104,7 @@ class SearchView(WidgetView):
         requests, page_data = paginate(
             data["requests"], instance.config["per_page"])
         data["requests"] = requests
-        data["page"] = page_data
-        return data
+        return dict(status="OK", data=data, page=page_data)
 
 
 class RequestersView(WidgetView):
@@ -123,7 +125,7 @@ class RequestersView(WidgetView):
         if query:
             results = [name for name in results if name.startswith(query)]
         results = sorted(list(results))[:self.MAX_SUGGESTS]
-        return {"results": results}
+        return {"status": "OK", "data": results}
 
 
 def hubs_suggest_view():
@@ -136,4 +138,4 @@ def hubs_suggest_view():
         results = results.filter(Hub.name.ilike(
             "%s%%" % flask.request.args.get("q")))
     results = results.order_by(Hub.name)[:MAX_SUGGESTS]
-    return flask.jsonify({"results": [h.name for h in results]})
+    return flask.jsonify({"status": "OK", "data": [h.name for h in results]})

